package it.inaf.oats.ia2.tapschemamanager.webapp;

import it.inaf.oats.ia2.tapschemamanager.datalayer.Credentials;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
//@Stateful
public class ApplicationManager {// implements ApplicationManagerLocal {

    String currentPage;

    private boolean isLoggedIn;

    private Credentials credentials;
    private SelectTapSchemaModel selectTapSchemaModel;
    private EditTapSchemaPageState editTapSchemaPageState;

    public ApplicationManager() {
        init();
    }

    private void init() {
        credentials = new Credentials();
        currentPage = TSMPages.CREDENTIALS;
        isLoggedIn = false;
        selectTapSchemaModel = null;
        editTapSchemaPageState = null;
    }

    public boolean isLoggedIn() {
        return isLoggedIn;
    }

    public Credentials getCredentials() {
        return this.credentials;
    }

    public SelectTapSchemaModel getSelectTapSchema() {
        return this.selectTapSchemaModel;
    }

    public void setSelectTapSchemaModel(SelectTapSchemaModel selectTapSchemaModel) {
        this.selectTapSchemaModel = selectTapSchemaModel;
        this.isLoggedIn = true;
    }

    public EditTapSchemaPageState getEditTapSchemaPageState() {
        return this.editTapSchemaPageState;
    }

    public void setEditTapSchemaPageState(EditTapSchemaPageState editTapSchemaPageState) {
        this.editTapSchemaPageState = editTapSchemaPageState;
    }

    public String getCurrentPage() {
        return this.currentPage;
    }

    public void setCurrentPage(String pageName) {
        this.currentPage = pageName;

        if (currentPage.equals(TSMPages.CREDENTIALS)) {
            init();
        } else if (currentPage.equals(TSMPages.SELECT_SCHEMA)) {
            editTapSchemaPageState = null;
        }
    }
}
