package it.inaf.oats.ia2.tapschemamanager.webapp;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import it.inaf.oats.ia2.tapschemamanager.businesslayer.TapSchema;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
public class EditTapSchemaPageState {

    private static final Gson NULLABLE_GSON = new GsonBuilder().serializeNulls().create();

    private final TapSchema tapSchema;
    private EditTapSchemaPageModel previousModel;
    private final SearchUCDDialog searchUCDDialog;

    public EditTapSchemaPageState(TapSchema tapSchema) {
        this.tapSchema = tapSchema;
        this.searchUCDDialog = new SearchUCDDialog();
    }

    public void setPreviousModel(EditTapSchemaPageModel pageModel) {
        this.previousModel = pageModel;
    }

    public EditTapSchemaPageModel getPreviousModel() {
        return previousModel;
    }

    public TapSchema getTapSchema() {
        return tapSchema;
    }

    public SearchUCDDialog getSearchUCDDialog() {
        return searchUCDDialog;
    }
}
